// Code generated by protoc-gen-validate. DO NOT EDIT.
// source: user/v1/resellers.proto

package user

import (
	"bytes"
	"errors"
	"fmt"
	"net"
	"net/mail"
	"net/url"
	"regexp"
	"strings"
	"time"
	"unicode/utf8"

	"github.com/golang/protobuf/ptypes"
)

// ensure the imports are used
var (
	_ = bytes.MinRead
	_ = errors.New("")
	_ = fmt.Print
	_ = utf8.UTFMax
	_ = (*regexp.Regexp)(nil)
	_ = (*strings.Reader)(nil)
	_ = net.IPv4len
	_ = time.Duration(0)
	_ = (*url.URL)(nil)
	_ = (*mail.Address)(nil)
	_ = ptypes.DynamicAny{}
)

// define the regex for a UUID once up-front
var _resellers_uuidPattern = regexp.MustCompile("^[0-9a-fA-F]{8}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{4}-[0-9a-fA-F]{12}$")

// Validate checks the field values on GetResellersResponse with the rules
// defined in the proto definition for this message. If any rules are
// violated, an error is returned.
func (m *GetResellersResponse) Validate() error {
	if m == nil {
		return nil
	}

	if v, ok := interface{}(m.GetMeta()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return GetResellersResponseValidationError{
				field:  "Meta",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	for idx, item := range m.GetObjects() {
		_, _ = idx, item

		if v, ok := interface{}(item).(interface{ Validate() error }); ok {
			if err := v.Validate(); err != nil {
				return GetResellersResponseValidationError{
					field:  fmt.Sprintf("Objects[%v]", idx),
					reason: "embedded message failed validation",
					cause:  err,
				}
			}
		}

	}

	return nil
}

// GetResellersResponseValidationError is the validation error returned by
// GetResellersResponse.Validate if the designated constraints aren't met.
type GetResellersResponseValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e GetResellersResponseValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e GetResellersResponseValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e GetResellersResponseValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e GetResellersResponseValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e GetResellersResponseValidationError) ErrorName() string {
	return "GetResellersResponseValidationError"
}

// Error satisfies the builtin error interface
func (e GetResellersResponseValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sGetResellersResponse.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = GetResellersResponseValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = GetResellersResponseValidationError{}

// Validate checks the field values on Reseller with the rules defined in the
// proto definition for this message. If any rules are violated, an error is returned.
func (m *Reseller) Validate() error {
	if m == nil {
		return nil
	}

	// no validation rules for Id

	// no validation rules for CsDomainId

	// no validation rules for DisplayName

	// no validation rules for ActivationContent

	// no validation rules for ActivationMethod

	// no validation rules for AllowSignUp

	// no validation rules for BillingReference

	// no validation rules for CsDomainName

	if v, ok := interface{}(m.GetDateCreated()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ResellerValidationError{
				field:  "DateCreated",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	if v, ok := interface{}(m.GetDateEdited()).(interface{ Validate() error }); ok {
		if err := v.Validate(); err != nil {
			return ResellerValidationError{
				field:  "DateEdited",
				reason: "embedded message failed validation",
				cause:  err,
			}
		}
	}

	// no validation rules for DeactivationContent

	// no validation rules for DeactivationMethod

	// no validation rules for DefaultInstanceLimit

	// no validation rules for DefaultIpLimit

	// no validation rules for DefaultNetworkLimit

	// no validation rules for DisablePaywall

	// no validation rules for DisablePersonalAccounts

	// no validation rules for Domain

	// no validation rules for EmailForTemplates

	// no validation rules for Enabled

	// no validation rules for IsCahnnel

	// no validation rules for Level

	// no validation rules for Lft

	// no validation rules for Name

	// no validation rules for RedirectPath

	// no validation rules for RegisterEmails

	// no validation rules for ResourceUri

	// no validation rules for Rght

	// no validation rules for SamlLogin

	// no validation rules for SamlUrl

	// no validation rules for SendEmails

	// no validation rules for SiteName

	// no validation rules for Slug

	// no validation rules for TreeId

	// no validation rules for UseResellerEmailTemplates

	return nil
}

// ResellerValidationError is the validation error returned by
// Reseller.Validate if the designated constraints aren't met.
type ResellerValidationError struct {
	field  string
	reason string
	cause  error
	key    bool
}

// Field function returns field value.
func (e ResellerValidationError) Field() string { return e.field }

// Reason function returns reason value.
func (e ResellerValidationError) Reason() string { return e.reason }

// Cause function returns cause value.
func (e ResellerValidationError) Cause() error { return e.cause }

// Key function returns key value.
func (e ResellerValidationError) Key() bool { return e.key }

// ErrorName returns error name.
func (e ResellerValidationError) ErrorName() string { return "ResellerValidationError" }

// Error satisfies the builtin error interface
func (e ResellerValidationError) Error() string {
	cause := ""
	if e.cause != nil {
		cause = fmt.Sprintf(" | caused by: %v", e.cause)
	}

	key := ""
	if e.key {
		key = "key for "
	}

	return fmt.Sprintf(
		"invalid %sReseller.%s: %s%s",
		key,
		e.field,
		e.reason,
		cause)
}

var _ error = ResellerValidationError{}

var _ interface {
	Field() string
	Reason() string
	Key() bool
	Cause() error
	ErrorName() string
} = ResellerValidationError{}
